Imports System
Imports System.ComponentModel

Imports DevExpress.Xpo
Imports DevExpress.Data.Filtering

Imports DevExpress.ExpressApp
Imports DevExpress.Persistent.Base
Imports DevExpress.Persistent.BaseImpl
Imports DevExpress.Persistent.Validation
Public Enum eOfferAnswerOutState
    eInProgress = 0 'Még dolgozunk rajta
    eClosedWON = 1 'Elfogadták
    eClosedLOST = 2 'Nem fogadták el
    eInThinkingOf = 3 'Még gondolkodnak, hogy mi legyen vele !
End Enum
<DefaultClassOptions(), NavigationItem(False), CreatableItem(False)> _
Public Class OfferAnswerOut
    Inherits BaseObject

    Private _CustomersFrom As CustomersFrom
    Private _Customers As Customers
    Private _Contacts As Contacts
    Private _DateExecution As Date
    Private _DateValid As Date
    Private _JobNumberObjects As JobNumberObjects
    Private _OfferAnswerOutState As eOfferAnswerOutState

    Private _ObjectCreated As Date
    Private _UserCreated As User

    Private _HRPerson_Responsible As HRPerson
    Private _OfferAnswerOut As OfferAnswerOut

    Public Sub New(ByVal session As Session)
        MyBase.New(session)
        ' This constructor is used when an object is loaded from a persistent storage.
        ' Do not place any code here or place it only when the IsLoading property is false:
        ' if (!IsLoading){
        '   It is now OK to place your initialization code here.
        ' }
        ' or as an alternative, move your initialization code into the AfterConstruction method.
    End Sub
    Public Overrides Sub AfterConstruction()
        MyBase.AfterConstruction()
        ' Place here your initialization code.
    End Sub
    Protected Overrides Sub OnSaving()
        MyBase.OnSaving()
        If Session.IsNewObject(Me) Then
            ObjectCreated = GetSQLTime(Session)
            UserCreated = Session.GetObjectByKey(Of User)(Session.GetKeyValue(SecuritySystem.CurrentUser))
        End If
    End Sub

    Property CustomersFrom As CustomersFrom
        Get
            Return _CustomersFrom
        End Get
        Set(value As CustomersFrom)
            SetPropertyValue("CustomersFrom", _CustomersFrom, value)
        End Set
    End Property
    Property Customers As Customers
        Get
            Return _Customers
        End Get
        Set(value As Customers)
            SetPropertyValue("Customers", _Customers, value)
        End Set
    End Property
    Property Contacts As Contacts
        Get
            Return _Contacts
        End Get
        Set(value As Contacts)
            SetPropertyValue("Contacts", _Contacts, value)
        End Set
    End Property

    Property JobNumberObjects As JobNumberObjects
        Get
            Return _JobNumberObjects
        End Get
        Set(value As JobNumberObjects)
            SetPropertyValue("JobNumberObjects", _JobNumberObjects, value)
        End Set
    End Property
    Property OfferAnswerOutState As eOfferAnswerOutState
        Get
            Return _OfferAnswerOutState
        End Get
        Set(value As eOfferAnswerOutState)
            SetPropertyValue("OfferAnswerOutState", _OfferAnswerOutState, value)
        End Set
    End Property


    Property DateExecution As Date
        Get
            Return _DateExecution
        End Get
        Set(value As Date)
            SetPropertyValue("DateExecution", _DateExecution, value)
        End Set
    End Property
    Property DateValid As Date
        Get
            Return _DateValid
        End Get
        Set(value As Date)
            SetPropertyValue("DateValid", _DateValid, value)
        End Set
    End Property
    <NonCloneable> _
    Property ObjectCreated As Date
        Get
            Return _ObjectCreated
        End Get
        Set(value As Date)
            SetPropertyValue("ObjectCreated", _ObjectCreated, value)
        End Set
    End Property
    <NonCloneable> _
    Property UserCreated As User
        Get
            Return _UserCreated
        End Get
        Set(value As User)
            SetPropertyValue("UserCreated", _UserCreated, value)
        End Set
    End Property

    Property HRPerson_Responsible As HRPerson
        Get
            Return _HRPerson_Responsible
        End Get
        Set(value As HRPerson)
            SetPropertyValue("HRPerson_Responsible", _HRPerson_Responsible, value)
        End Set
    End Property
    Property OfferAnswerOut As OfferAnswerOut
        Get
            Return _OfferAnswerOut
        End Get
        Set(value As OfferAnswerOut)
            SetPropertyValue("OfferAnswerOut", _OfferAnswerOut, value)
        End Set
    End Property
    '//XPCollections
    <Association("OfferAnswerOut-OfferAnswerOutRows", GetType(OfferAnswerOutRows))> _
    ReadOnly Property OfferAnswerOutRows As XPCollection(Of OfferAnswerOutRows)
        Get
            Return GetCollection(Of OfferAnswerOutRows)("OfferAnswerOutRows")
        End Get
    End Property
    <Association("OfferAnswerOut-OfferAnswerOutDocuments", GetType(OfferAnswerOutDocuments)), VisibleInListView(False), VisibleInLookupListView(False)> _
    ReadOnly Property OfferAnswerOutDocuments As XPCollection(Of OfferAnswerOutDocuments)
        Get
            Return GetCollection(Of OfferAnswerOutDocuments)("OfferAnswerOutDocuments")
        End Get
    End Property

End Class
